<script lang="ts" setup>
import { onMounted, onUnmounted, ref } from "vue";
import axios from "axios";
import type { Header, SortType } from "vue3-easy-data-table";
import { useRouter } from "vue-router";

const props = defineProps(["id"]);

const tableData = ref([]);
const loading = ref(true);
const loadedOnce = ref(false);

let poll = true;
let timerRef = 0;
async function loadData() {
  const res = await axios.get(`${window.origin}/api/jobs/${props.id}`);
  tableData.value = res.data.executions;
}

async function doPolling() {
  if (!poll) return;

  loading.value = true;
  try {
    await loadData();
  } catch (error) {
    console.log(error);
  }
  loading.value = false;
  loadedOnce.value = true;

  timerRef = setTimeout(doPolling, 5000);
}

onMounted(() => {
  doPolling();
});

onUnmounted(() => {
  poll = false;
  clearTimeout(timerRef);
});

const router = useRouter();
function showRow(event: { id: string }) {
  router.push({ name: "logs", params: { id: props.id, executionId: event.id } });
}
</script>

<template>
  <div class="flex justify-between">
    <p className="text-left mb-6 text-xl">JobId: {{ props.id }}</p>
    <Spinner v-if="loadedOnce && loading" :size="30" />
  </div>
  <div class="items-left justify-center">
    <ExecutionsTable
      :tableData="tableData"
      :loading="!loadedOnce && loading"
      @click-row="showRow"
    />
  </div>
</template>
